unit U_DJBCKOutList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit,
  RM_BarCode, cxMaskEdit, cxContainer, cxCurrencyEdit, cxPC, cxLookAndFeels,
  cxLookAndFeelPainters, cxNavigator, dxBarBuiltInMenu, Printers, dxSkinsCore,
  dxSkinsDefaultPainters, dxSkinscxPCPainter;

type
  TfrmDJBCKOutList = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column7: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    v1Column10: TcxGridDBColumn;
    v1Column16: TcxGridDBColumn;
    v1Column9: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    v1Column5: TcxGridDBColumn;
    v1Column19: TcxGridDBColumn;
    v1Column17: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    SPName: TEdit;
    FactoryName: TEdit;
    SPID: TEdit;
    spcode: TEdit;
    CRType: TComboBox;
    SPCF: TEdit;
    QCorderNo: TEdit;
    Label10: TLabel;
    CKorderNo: TEdit;
    Label11: TLabel;
    FromFactoryName: TEdit;
    Label13: TLabel;
    ToFactoryName: TEdit;
    Label9: TLabel;
    Label14: TLabel;
    RCGangNo: TEdit;
    GangNo: TEdit;
    v1Column15: TcxGridDBColumn;
    v1Column20: TcxGridDBColumn;
    ToolButton3: TToolButton;
    ADOQueryPrint: TADOQuery;
    v1Column21: TcxGridDBColumn;
    Label15: TLabel;
    SPColor: TEdit;
    Label16: TLabel;
    PRTColorNo: TEdit;
    Label17: TLabel;
    SPHX: TEdit;
    RM1: TRMGridReport;
    RMBarCodeObject1: TRMBarCodeObject;
    v1Column22: TcxGridDBColumn;
    v1Column23: TcxGridDBColumn;
    v1Column24: TcxGridDBColumn;
    Label18: TLabel;
    CustomerNoName: TEdit;
    N3: TMenuItem;
    ToolButton1: TToolButton;
    v1Column18: TcxGridDBColumn;
    Label19: TLabel;
    LBNO: TEdit;
    ToolButton2: TToolButton;
    PiZhong: TEdit;
    v1Column25: TcxGridDBColumn;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    v1Column26: TcxGridDBColumn;
    Panel4: TPanel;
    Label20: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label21: TLabel;
    cxCurrencyEdit1: TcxCurrencyEdit;
    Button1: TButton;
    Button2: TButton;
    cxCurrencyEdit2: TcxCurrencyEdit;
    QTYUNIT: TComboBox;
    JGC: TcxButtonEdit;
    jgcno: TcxCurrencyEdit;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    ToolButton6: TToolButton;
    v1Column27: TcxGridDBColumn;
    Label22: TLabel;
    JYZT: TComboBox;
    cxTabControl1: TcxTabControl;
    ToolButton7: TToolButton;
    v1Column28: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    cxStyleRepository1: TcxStyleRepository;
    cxStyle1: TcxStyle;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    ToolButton8: TToolButton;
    Panel2: TPanel;
    Label26: TLabel;
    Label27: TLabel;
    Button7: TButton;
    Button6: TButton;
    Label23: TLabel;
    Label28: TLabel;
    cxCurrencyEdit3: TcxCurrencyEdit;
    cxCurrencyEdit4: TcxCurrencyEdit;
    Label29: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Tv1Column5: TcxGridDBColumn;
    Tv1Column6: TcxGridDBColumn;
    EDIT2: TcxButtonEdit;
    EDIT3: TcxButtonEdit;
    ToolButton9: TToolButton;
    CheckBox1: TCheckBox;
    Panel3: TPanel;
    Label34: TLabel;
    Label33: TLabel;
    ComboBox2: TComboBox;
    Button8: TButton;
    Button10: TButton;
    Button11: TButton;
    ToolButton10: TToolButton;
    Edit1: TEdit;
    Tv1Column7: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure SPNameChange(Sender: TObject);
    procedure SPIDKeyPress(Sender: TObject; var Key: Char);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure N3Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure ToolButton4Click(Sender: TObject);
    procedure ToolButton5Click(Sender: TObject);
    procedure ToolButton6Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure JGCPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ToolButton7Click(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure Tv1CustomDrawIndicatorCell(Sender: TcxGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxCustomGridIndicatorItemViewInfo; var ADone: Boolean);
    procedure CKorderNoKeyPress(Sender: TObject; var Key: Char);
    procedure CKorderNoChange(Sender: TObject);
    procedure ToolButton8Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure EDIT2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure EDIT3PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure ToolButton9Click(Sender: TObject);
    procedure JYZTChange(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure ToolButton10Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Tv1CustomDrawCell(Sender: TcxCustomGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean);
  private
    canshu1, canshu2: string;
    procedure InitGrid();
    { Private declarations }
  public
    { Public declarations }
  end;
             //取得本机打印机列表，可不调用。

function GetCurrentPrinterHandle: THandle;

var
  frmDJBCKOutList: TfrmDJBCKOutList;

implementation

uses
  U_DataLink, U_RTFun, U_Fun, U_DJBCKOutPut, U_ZdyAttachGYS, U_ZDYHelp;

{$R *.dfm}
function GetCurrentPrinterHandle: THandle;
var
  Device, Driver, Port: array[0..255] of char;
  hDeviceMode: THandle;
begin
  Printer.GetPrinter(Device, Driver, Port, hDeviceMode);
//  if not OpenPrinter(@Device, Result, nil) then
//    RaiseLastWin32Error;
end;

procedure TfrmDJBCKOutList.FormDestroy(Sender: TObject);
begin
  frmDJBCKOutList := nil;
end;

procedure TfrmDJBCKOutList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmDJBCKOutList.FormCreate(Sender: TObject);
begin
  ComboBox2.Items.Assign(Printer.Printers);
//  ComboBox2.ItemIndex := 0; //指向第一台打印机
  ComboBox2.Items.Add('默认打印机');
  ComboBox2.ItemIndex := Self.ComboBox2.Items.IndexOf(trim('默认打印机'));
  //cxGrid1.Align:=alClient;
  canshu1 := Trim(DParameters1);
  canshu2 := Trim(DParameters2);
  EndDate.DateTime := SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 7;
end;

procedure TfrmDJBCKOutList.InitGrid();
var
  fwhere, Pwhere: string;
begin
  Pwhere := SGetFilters(Panel1, 1, 2);
  begin
    if trim(Pwhere) <> '' then
      fwhere := fwhere + ' and ' + trim(Pwhere);
  end;
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;

      SQL.Add('SELECT * FROM (    ');
      sql.Add(' select A.*,JYZT=(case when   a.piqty<=(SELECT COUNT(*)FROM WFB_MJJY D WHERE A.SPID=D.APID) THEN ''成检完成''  ');
      SQL.Add('when  a.piqty>(SELECT COUNT(*)FROM WFB_MJJY D WHERE A.SPID=D.APID) and exists(select * from WFB_MJJY where APID=A.SPID) then ''成检中'' else ''等待成检'' end)  ');
      SQL.Add(',JYPS=DJJS,JYZL=DJMZ,JYCD=DJLEN');
      SQL.Add(',sunhao2=abs(sunhao)');
//      SQL.Add(',JYPS=(SELECT COUNT(*)FROM CK_BanCP_CR D WHERE A.SPID=D.APID and crflag=''出库'' and  crtype<>''回修出库'')');
//      SQL.Add(',JYCD=(SELECT SUM(qty)FROM CK_BanCP_CR D WHERE A.SPID=D.APID and crflag=''出库'' and  crtype<>''回修出库'')');
//      SQL.Add(',JYZL=(SELECT  SUM(kgqty)FROM CK_BanCP_CR D WHERE A.SPID=D.APID and crflag=''出库'' and  crtype<>''回修出库'')');
//      SQL.Add(',JYPS=(SELECT COUNT(*)FROM WFB_MJJY D WHERE A.SPID=D.APID and not EXISTS(select mjid from CK_BanCP_CR B where b.MJID=d.MJID and ISNULL(b.crtype,'''')=''回修出库''))');
//      SQL.Add(',JYCD=(SELECT SUM(MJLEN)FROM WFB_MJJY D WHERE A.SPID=D.APID and not EXISTS(select mjid from CK_BanCP_CR B where b.MJID=d.MJID and ISNULL(b.crtype,'''')=''回修出库''))');
//      SQL.Add(',JYZL=(SELECT SUM(MJMAOZ)FROM WFB_MJJY D WHERE A.SPID=D.APID and not EXISTS(select mjid from CK_BanCP_CR B where b.MJID=d.MJID and ISNULL(b.crtype,'''')=''回修出库''))');
      sql.Add(',PRTColorNo=(select PRTColorNo from JYOrder_sub C where A.ORDSubIdCK=C.SUBID )');
      sql.Add(',DDYSS=(select PRTOrderQty from JYOrder_sub C where A.ORDSubIdCK=C.SUBID )');
      sql.Add(',PRTHX1=(select PRTHX from JYOrder_sub C where A.ORDSubIdCK=C.SUBID )');
      sql.Add(' from CK_SXPB_CR A ');
      sql.add(' where   1=1 ');
      if CKorderNo.Text <> '' then
      begin
        SQL.Add('AND CKorderNo LIKE ' + QuotedStr('%' + Trim(CKorderNo.Text)));
      end;
      if CheckBox1.Checked = True then
      begin
        sql.Add('and A.CRTime>=' + quotedstr(Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime))));
        sql.add(' and A.CRTime<' + quotedstr(Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1))));
      end;

      SQL.Add(' and CRFlag=''出库''  ');
      SQL.Add(' and isnull(CKName,'''')=''待检布'' ');

      SQL.Add(') AA WHERE 1=1');
      sql.Add(fwhere);
      if cxTabControl1.TabIndex = 0 then
      begin
        SQL.Add('AND PrintCount=0');
      end
      else if cxTabControl1.TabIndex = 1 then
      begin
        SQL.Add('AND PrintCount>0');
      end;
      SQL.Add('order by  CKorderNo,SPColor,[dbo].[getNum](GangNo)  ');

      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
  TBFind.Click;

end;

procedure TfrmDJBCKOutList.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmDJBCKOutList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmDJBCKOutList.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('待检布出库列表', Tv1, '外加工仓库');
  Close;
end;

procedure TfrmDJBCKOutList.FormShow(Sender: TObject);
begin
  if Trim(canshu2) = '查看' then
  begin
    TBAdd.Visible := False;
    TBDel.Visible := False;
    TBEdit.Visible := False;
  end
  else
  begin
    TBAdd.Visible := True;
    TBDel.Visible := True;
    TBEdit.Visible := True;
  end;
  ReadCxGrid('待检布出库列表', Tv1, '外加工仓库');
  InitGrid();
end;

procedure TfrmDJBCKOutList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel('外加工出库列表', cxGrid2);
end;

procedure TfrmDJBCKOutList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmDJBCKOutList.SPNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmDJBCKOutList.SPIDKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    {if Length(Trim(SPID.Text))<4 then Exit;
    try
      ADOQueryMain.DisableControls;
      with ADOQueryMain do
      begin
        Filtered:=False;
        Close;
        sql.Clear;
        sql.Add(' select A.* ');
        sql.Add(' from CK_SXPB_CR A');
        sql.add(' where SPID like :SXID');
        Parameters.ParamByName('SXID').Value:='%'+Trim(SXID.Text)+'%';
        Open;
        //ShowMessage(SQL.Text);
      end;
      SCreateCDS20(ADOQueryMain,CDS_Main);
      SInitCDSData20(ADOQueryMain,CDS_Main);
    finally
      ADOQueryMain.EnableControls;
    end; }
    InitGrid();
  end;
end;

procedure TfrmDJBCKOutList.N1Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while not eof do
    begin
      if Trim(CDS_Main.fieldbyname('CRType').AsString) = '检验出库' then
      begin
        Edit;
        FieldByName('SSel').Value := True;
        Post;
      end;
      Next;
    end;
  end;
  CDS_Main.EnableControls;
end;

procedure TfrmDJBCKOutList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmDJBCKOutList.TBDelClick(Sender: TObject);
var
  strsql: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('已检验不能删除数据!', '提示', 0);
    Exit;
  end;
  if Application.MessageBox('确定要删除选择的数据吗？', '提示', 32 + 4) <> IDYES then
    Exit;
  try
    ADOQueryCmd.Connection.BeginTrans;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      if Trim(CDS_Main.fieldbyname('SPID').AsString) <> '' then
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from YF_MONEY_CR A inner join YF_MONEY_CR_sub B on A.YFID=B.YFID ');
          sql.Add('where  A.status=''1'' and B.YFPZNO=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
          Open;
        end;
        if ADOQueryTemp.IsEmpty = False then
        begin
          Application.MessageBox('财务数据已确认不能操作!', '提示', 0);
          Exit;
        end;

        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select Top 1 * from WFB_MJJY where isnull(APID,'''')=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
          Open;
        end;
        if ADOQueryTemp.IsEmpty = False then
        begin
          Application.MessageBox('已检验不能删除数据!', '提示', 0);
          Exit;
        end;
        if Trim(CDS_Main.fieldbyname('CRType').AsString) = '加工出库' then
        begin
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where FZSPID=');
            sql.Add('(select SPID from CK_SXPB_CR where PYID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            sql.Add(' and isnull(CRType,'''')=''平移入库'')');
            sql.Add(' and CRQtyFlag=-1');
            Open;
          end;
          if ADOQueryTemp.IsEmpty = False then
          begin
            Application.MessageBox('已有出库记录，不能删除!', '提示', 0);
            Exit;
          end;
        end;

        with ADOQueryTemp do
        begin
          close;
          sql.Clear;
          sql.Add('SELECT * FROM YF_MONEY_CR   ');
          sql.Add('where YFID=' + quotedstr(trim('D' + CDS_Main.fieldbyname('SPID').AsString)));
          SQL.Add('AND STATUS=1');
          Open;
        end;
        if ADOQueryTemp.IsEmpty = False then
        begin
          application.MessageBox('财务已审核，禁止撤销！', '提示信息');
          Exit;
        end;
        strsql := '来自记录：' + Trim(CDS_Main.fieldbyname('FZSPID').AsString) + ';当前记录:' + Trim(CDS_Main.fieldbyname('SPID').AsString);
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add(' delete CK_SXPB_CR where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
          sql.Add(' Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(',MXKCPiQty=(select sum(isnull(PiQty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');
          sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('FZSPID').AsString) + '''');

          sql.Add(' exec P_CW_SXPB ''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');

          if Trim(CDS_Main.fieldbyname('CRType').AsString) = '加工出库' then
          begin
            sql.Add(' delete CK_SXPB_CR where CRType=''平移入库''  and  PYID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
          end;

          if Trim(CDS_Main.fieldbyname('CRType').AsString) = '销售出库' then
          begin
            sql.Add(' delete YF_MONEY_CR  where YFID=' + quotedstr(trim('D' + CDS_Main.fieldbyname('SPID').AsString)));
            sql.Add(' delete YF_MONEY_CR_SUB  where YFID=' + quotedstr(trim('D' + CDS_Main.fieldbyname('SPID').AsString)));
          end;
          sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
          sql.Add(' ' + quotedstr(trim(DName)));
          sql.Add(',getdate() ');
          sql.Add(',' + quotedstr(trim(self.Caption)));
          sql.Add(',' + quotedstr(trim('删除待检布出库')));
          sql.Add(',' + quotedstr(trim(strsql)));
          sql.Add(',' + quotedstr(trim('成功')));
          sql.Add(')');
          ExecSQL;

        end;
      end;
      CDS_Main.Delete;
    end;
    ADOQueryCmd.Connection.CommitTrans;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('删除异常!', '提示', 0);
  end;
end;

procedure TfrmDJBCKOutList.TBAddClick(Sender: TObject);
begin
  try
    frmDJBCKOutPut := TfrmDJBCKOutPut.Create(Application);
    with frmDJBCKOutPut do
    begin
      FBCId := '';
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmDJBCKOutPut.Free;
  end;
end;

procedure TfrmDJBCKOutList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from YF_MONEY_CR A inner join YF_MONEY_CR_sub B on A.YFID=B.YFID ');
    sql.Add('where  A.status=''1'' and B.YFPZNO=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
    Open;
  end;
  if ADOQueryTemp.IsEmpty = False then
  begin
    Application.MessageBox('财务数据已确认不能操作!', '提示', 0);
    Exit;
  end;

  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add('select * from CK_SXPB_CR where FZSPID=');
    sql.Add('(select SPID from CK_SXPB_CR where PYID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
    sql.Add(' and isnull(CRType,'''')=''平移入库'')');
    sql.Add(' and CRQtyFlag=-1');
    Open;
  end;
  if ADOQueryTemp.IsEmpty = False then
  begin
    Application.MessageBox('已有出库记录，不能修改!', '提示', 0);
    Exit;
  end;
  try
    frmDJBCKOutPut := TfrmDJBCKOutPut.Create(Application);
    with frmDJBCKOutPut do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('SPID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmDJBCKOutPut.Free;
  end;

end;

procedure TfrmDJBCKOutList.ToolButton3Click(Sender: TObject);
var
  fPrintFile: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
begin
  if CDS_Main.IsEmpty then
    Exit;
  //if Trim(CDS_Main.fieldbyname('CRType').AsString)<>'检验出库' then Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('检验指示单标签.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签.rmf';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' update CK_SXPB_CR set PrintCount=isnull(PrintCount,0)+1 ');
        sql.Add(' where SPId=''' + Trim(CDS_Main.fieldbyname('SPId').AsString) + ''' ');
        ExecSQL;
      end;
      with ADOQueryPrint do
      begin
        Close;
        sql.Clear;
        sql.Add(' select A.* ,B.SOrddefstr1,B.PRTColor,B.PRTHX,C.OrderNo,C.MPRTCodeName');
        sql.Add(',C.CustomerNoName,C.ConNo,C.LYnoet');
        sql.Add(',khCode=(select zdyNameZ from KH_Zdy_Attachment X where X.zdyname=C.CustomerNoName and X.Type=''KHName'') ');
        sql.Add(',khConNo=(select top 1 khConNo from JYOrderCon_Main X where X.ConNO=C.conNO) ');
        sql.Add(' from CK_SXPB_CR A');
        sql.Add(' left join JYOrder_Sub B on A.ORDSubIdCK=B.SubId');
        sql.Add(' left join JYOrder_Main C on A.ORDMainIdCK=C.MainId');

        sql.Add(' where A.SPId=''' + Trim(CDS_Main.fieldbyname('SPId').AsString) + '''');

        if cxTabControl1.TabIndex = 0 then
        begin
          SQL.Add('AND PrintCount=0');
        end
        else if cxTabControl1.TabIndex = 1 then
        begin
          SQL.Add('AND PrintCount<>0');
        end;
        Open;
      end;
      SCreateCDS20(ADOQueryPrint, CDS_PRT);
      SInitCDSData20(ADOQueryPrint, CDS_PRT);

      try
        Moudle := LoadLibrary('MakeQRBarcode.dll');
        @Makebar := GetProcAddress(Moudle, 'Make');
        @Mixtext := GetProcAddress(Moudle, 'MixText');
        Txt := Trim(CDS_PRT.fieldbyname('SPID').AsString);
        fImagePath := ExtractFilePath(Application.ExeName) + 'image\temp.bmp';
        if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName) + 'image')) then
          CreateDirectory(pchar(ExtractFilePath(Application.ExeName) + 'image'), nil);
        if FileExists(fImagePath) then
          DeleteFile(fImagePath);
        Makebar(pchar(Txt), Length(Txt), 3, 3, 0, PChar(fImagePath), 3);
      except
        CDS_Main.EnableControls;
        application.MessageBox('条形码生成失败！', '提示信息', MB_ICONERROR);
        exit;
      end;

      if FileExists(fPrintFile) then
      begin
        RMVariables['QRBARCODE'] := fImagePath;
        RM1.LoadFromFile(fPrintFile);
        //RM1.ShowReport;
        RM1.PrintReport;
      end
      else
      begin
        CDS_Main.EnableControls;
        Application.MessageBox(PChar('没有找' + ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签.rmf'), '提示', 0);
        Exit;
      end;
      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;

end;

procedure TfrmDJBCKOutList.Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
//  if CDS_Main.IsEmpty then Exit;
//  if Trim(CDS_Main.fieldbyname('CRType').AsString)<>'检验出库' then
//  begin
//    Tv1.OptionsSelection.CellSelect:=False;
//  end else
//  begin
//    Tv1.OptionsSelection.CellSelect:=True;
//  end;
end;

procedure TfrmDJBCKOutList.N3Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while not eof do
    begin
      Edit;
      FieldByName('SSel').Value := True;
      Post;
      Next;
    end;
  end;
  CDS_Main.EnableControls;
end;

procedure TfrmDJBCKOutList.ToolButton1Click(Sender: TObject);
var
  fPrintFile: string;
var
  WSql, WSQL2: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('检验指示单标签A4.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf';
  WSql := '';
  WSQL2 := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      if WSql <> '' then
      begin
        WSql := WSql + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
        WSQL2 := WSQL2 + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      end
      else
      begin
        WSql := 'where A.SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
        WSQL2 := 'where SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      end;
      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;
  WSql := WSql + ')';
  WSQL2 := WSQL2 + ')';

  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add(' update CK_SXPB_CR  set PrintCount=isnull(PrintCount,0)+1 ');
    sql.Add(WSQL2);
//    ShowMessage(SQL.Text);
    ExecSQL;
  end;
  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
//    sql.Add(' select A.*,D.*  ');
//    sql.Add(',KHConno=(select KHConno from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(',MPRTBZNote=(select MPRTBZNote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(',PRTColorNo=(select PRTColorNo from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',PRTOrderQty=(select PRTOrderQty from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',PRTEColor=(select PRTEColor from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',LYnote=(select LYnote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(' from CK_SXPB_CR A');
//    sql.Add(' left join TP_File D on D.TFID=A.SPID ');

    sql.Add(' EXEC P_Print_JYZSD @WSql=' + QuotedStr(WSql));
//    ShowMessage(SQL.Text);
    Open;
  end;
  SCreateCDS20(ADOQueryPrint, CDS_PRT);
  SInitCDSData20(ADOQueryPrint, CDS_PRT);

  if FileExists(fPrintFile) then
  begin
    RM1.LoadFromFile(fPrintFile);
    RM1.DefaultCopies := StrToIntDef(Edit1.Text, 1);
    RM1.ShowPrintDialog := FALSE;
    RM1.ShowReport;
//    RM1.PrintReportL(ComboBox2.Text);
  end
  else
  begin
    CDS_Main.EnableControls;
    Application.MessageBox(PChar('没有找' + ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf'), '提示', 0);
    Exit;
  end;
end;

procedure TfrmDJBCKOutList.ToolButton2Click(Sender: TObject);
var
  FGWZ, QSJH, JGJS, i: Integer;
  qq, bb: string;
begin
  i := 0;
  FGWZ := pos('-', Trim(PiZhong.Text));
  QSJH := StrToIntDef(Copy(Trim(PiZhong.Text), 0, FGWZ - 1), 0);
  JGJS := StrToIntDef(Copy(Trim(PiZhong.Text), FGWZ + 1, Length(Trim(PiZhong.Text))), 0);

  if FGWZ = 0 then
  begin
    Application.MessageBox('开始卷号异常!', '提示', 0);
    Exit;
  end;
  if QSJH = 0 then
  begin
    Application.MessageBox('开始卷号异常!', '提示', 0);
    Exit;
  end;
  if JGJS = 0 then
  begin
    Application.MessageBox('开始卷号异常!', '提示', 0);
    Exit;
  end;
  with CDS_Main do
  begin
    First;
    while not Eof do
    begin
      if CDS_Main.FieldByName('SSel').AsBoolean then
      begin
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update CK_SXPB_CR Set KSJH=' + IntToStr(QSJH + JGJS * i));
          sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
//          ShowMessage(SQL.Text);
          ExecSQL;
        end;
        with CDS_Main do
        begin
          Edit;
          FieldByName('SSel').Value := False;
          FieldByName('KSJH').Value := QSJH + JGJS * i;
          Post;
        end;

        i := i + 1;
      end;
      Next;
    end;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmDJBCKOutList.ToolButton4Click(Sender: TObject);
var
  FReal: Double;
begin
  if Trim(PiZhong.Text) = '' then
  begin
    Application.MessageBox('换算系数不能为空!', '提示', 0);
    Exit;
  end;
  if TryStrToFloat(PiZhong.Text, FReal) = False then
  begin
    Application.MessageBox('换算系数非法数字!', '提示', 0);
    Exit;
  end;
  while CDS_Main.Locate('SSel', True, []) do
  begin
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('Update CK_SXPB_CR Set XS=' + (PiZhong.Text));
      sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
      ExecSQL;
    end;
    with CDS_Main do
    begin
      Edit;
      FieldByName('SSel').Value := False;
      FieldByName('XS').Value := PiZhong.Text;
      Post;
    end;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmDJBCKOutList.ToolButton5Click(Sender: TObject);
var
  FReal: Double;
begin
  if Trim(PiZhong.Text) = '' then
  begin
    Application.MessageBox('通尺不能为空!', '提示', 0);
    Exit;
  end;
  if TryStrToFloat(PiZhong.Text, FReal) = False then
  begin
    Application.MessageBox('通尺非法数字!', '提示', 0);
    Exit;
  end;
  while CDS_Main.Locate('SSel', True, []) do
  begin
    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add('Update CK_SXPB_CR Set TongChi=' + PiZhong.Text);
      sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
      ExecSQL;
    end;
    with CDS_Main do
    begin
      Edit;
      FieldByName('SSel').Value := False;
      FieldByName('TongChi').Value := PiZhong.Text;
      Post;
    end;
  end;
  tv1.Controller.EditingController.ShowEdit();
end;

procedure TfrmDJBCKOutList.ToolButton6Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  Panel4.Visible := True;
end;

procedure TfrmDJBCKOutList.Button2Click(Sender: TObject);
begin
  JGC.Text := '';
  jgcno.Text := '';
  QTYUNIT.Text := '';
  cxCurrencyEdit1.Text := '';
  cxCurrencyEdit2.Text := '';
  Panel4.Visible := false;
end;

procedure TfrmDJBCKOutList.JGCPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZdyAttachGYS := TfrmZdyAttachGYS.Create(Application);
    with frmZdyAttachGYS do
    begin
      if ShowModal = 1 then
      begin
        JGC.Text := Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('CoName').AsString);
        jgcno.Text := Trim(frmZdyAttachGYS.CDS_HZ.fieldbyname('Cocode').AsString);
      end;
    end;
  finally
    frmZdyAttachGYS.Free;
  end;
end;

procedure TfrmDJBCKOutList.Button1Click(Sender: TObject);
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Main.DisableControls;
    with CDS_Main do
    begin
      First;
      while not Eof do
      begin
        if CDS_Main.FieldByName('SSel').AsBoolean = True then
        begin

          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('select * from YF_MONEY_CR A inner join YF_MONEY_CR_sub B on A.YFID=B.YFID ');
            sql.Add('where  A.status=''1'' and B.YFPZNO=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            Open;
          end;
          if ADOQueryCmd.IsEmpty = False then
          begin
            CDS_Main.EnableControls;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('财务已确认,禁止修改!', '提示', 0);
            Exit;
          end;

          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from YF_MONEY_CR A inner join YF_MONEY_CR_sub B on A.YFID=B.YFID ');
            sql.Add('where  A.status=''1'' and B.YFPZNO=''' + Trim(CDS_Main.fieldbyname('fzSPID').AsString) + '''');
            Open;
          end;
          if ADOQueryTemp.IsEmpty = False then
          begin
            CDS_Main.EnableControls;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('财务已确认,禁止修改!', '提示', 0);
            Exit;
          end;

          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('exec P_Update_SXPB_Factory ' + quotedstr(trim(Self.CDS_Main.FieldByName('FZSPID').AsString)) + ',' + quotedstr(Trim(JGCNO.Text)) + ',' + quotedstr(Trim(JGC.Text)));
            sql.Add(' exec P_CW_SXPB ''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            sql.Add(' exec P_CW_SXPB ''' + Trim(CDS_Main.fieldbyname('fzSPID').AsString) + '''');
            execsql;
          end;

          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
            sql.Add(' ' + quotedstr(trim(DName)));
            sql.Add(',getdate() ');
            sql.Add(',' + quotedstr(trim(self.Caption)));
            sql.Add(',' + quotedstr(trim('修改加工厂')));
            sql.Add(',' + quotedstr(trim('出库单号：' + trim(Self.CDS_Main.FieldByName('SPID').AsString) + ' 原加工厂:' + trim(Self.CDS_Main.FieldByName('FactoryName').AsString))));
            sql.Add(',' + quotedstr(trim('成功')));
            sql.Add(')');
            execsql;
          end;

        end;
        Next;
      end;
    end;
    CDS_Main.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Application.MessageBox('修改成功!', '提示', 0);
  except
    CDS_Main.EnableControls;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('修改异常!', '提示', 0);
    Exit;
  end;
end;

procedure TfrmDJBCKOutList.Button3Click(Sender: TObject);
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Main.DisableControls;
    with CDS_Main do
    begin
      First;
      while not Eof do
      begin
        if CDS_Main.FieldByName('SSel').AsBoolean = True then
        begin
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from YF_MONEY_CR A inner join YF_MONEY_CR_sub B on A.YFID=B.YFID ');
            sql.Add('where  A.status=''1'' and B.YFPZNO=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            Open;
          end;
          if ADOQueryTemp.IsEmpty = False then
          begin
            CDS_Main.EnableControls;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('财务数据已确认不能操作!', '提示', 0);
            Exit;
          end;
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from YF_MONEY_CR A inner join YF_MONEY_CR_sub B on A.YFID=B.YFID ');
            sql.Add('where  A.status=''1'' and B.YFPZNO=''' + Trim(CDS_Main.fieldbyname('fzSPID').AsString) + '''');
            Open;
          end;
          if ADOQueryTemp.IsEmpty = False then
          begin
            CDS_Main.EnableControls;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('财务数据已确认不能操作!', '提示', 0);
            Exit;
          end;
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('exec P_Update_SXPB_unit ' + quotedstr(trim(Self.CDS_Main.FieldByName('fzSPID').AsString)) + ',' + quotedstr(Trim(QTYUNIT.Text)));
            sql.Add(' exec P_CW_SXPB ''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            sql.Add(' exec P_CW_SXPB ''' + Trim(CDS_Main.fieldbyname('fzSPID').AsString) + '''');
            execsql;
          end;
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
            sql.Add(' ' + quotedstr(trim(DName)));
            sql.Add(',getdate() ');
            sql.Add(',' + quotedstr(trim(self.Caption)));
            sql.Add(',' + quotedstr(trim('修改单位')));
            sql.Add(',' + quotedstr(trim('出库单号：' + trim(Self.CDS_Main.FieldByName('SPID').AsString) + ' 原单位:' + trim(Self.CDS_Main.FieldByName('qtyunit').AsString))));
            sql.Add(',' + quotedstr(trim('成功')));
            sql.Add(')');
            execsql;
          end;

        end;
        Next;
      end;
    end;
    CDS_Main.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Application.MessageBox('修改成功!', '提示', 0);
  except
    CDS_Main.EnableControls;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('修改异常!', '提示', 0);
    Exit;
  end;
end;

procedure TfrmDJBCKOutList.Button4Click(Sender: TObject);
var
  FFreal: Double;
begin
  if Trim(cxCurrencyEdit1.Text) <> '' then
  begin
    if TryStrToFloat(cxCurrencyEdit1.Text, FFreal) = False then
    begin

      Application.MessageBox('匹数非法数字!', '提示', 0);
      Exit;
    end;
  end;

  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Main.DisableControls;
    with CDS_Main do
    begin
      First;
      while not Eof do
      begin
        if CDS_Main.FieldByName('SSel').AsBoolean = True then
        begin
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('select * from YF_MONEY_CR A inner join YF_MONEY_CR_sub B on A.YFID=B.YFID ');
            sql.Add('where  A.status=''1'' and B.YFPZNO=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            Open;
          end;
          if ADOQueryCmd.IsEmpty = False then
          begin
            CDS_Main.EnableControls;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('财务已确认,禁止修改!', '提示', 0);
            Exit;
          end;

          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('exec P_Update_SXPB_PS ' + quotedstr(trim(Self.CDS_Main.FieldByName('SPID').AsString)) + ',' + quotedstr(Trim(cxCurrencyEdit1.Text)));
            sql.Add(' exec P_CW_SXPB ''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            execsql;
          end;
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
            sql.Add(' ' + quotedstr(trim(DName)));
            sql.Add(',getdate() ');
            sql.Add(',' + quotedstr(trim(self.Caption)));
            sql.Add(',' + quotedstr(trim('修改匹数')));
            sql.Add(',' + quotedstr(trim('入库单号：' + trim(Self.CDS_Main.FieldByName('SPID').AsString) + ' 原匹数:' + trim(Self.CDS_Main.FieldByName('piqty').AsString))));
            sql.Add(',' + quotedstr(trim('成功')));
            sql.Add(')');
            execsql;
          end;

        end;
        Next;
      end;
    end;
    CDS_Main.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Application.MessageBox('修改成功!', '提示', 0);
  except
    CDS_Main.EnableControls;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('修改异常!', '提示', 0);
    Exit;
  end;

end;

procedure TfrmDJBCKOutList.Button5Click(Sender: TObject);
var
  FFREAL: Double;
begin
  if Trim(cxCurrencyEdit2.Text) <> '' then
  begin
    if TryStrToFloat(cxCurrencyEdit2.Text, FFREAL) = False then
    begin
      Application.MessageBox('匹数非法数字!', '提示', 0);
      Exit;
    end;
  end;
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Main.DisableControls;
    with CDS_Main do
    begin
      First;
      while not Eof do
      begin
        if CDS_Main.FieldByName('SSel').AsBoolean = True then
        begin

          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('select * from YF_MONEY_CR A inner join YF_MONEY_CR_sub B on A.YFID=B.YFID ');
            sql.Add('where  A.status=''1'' and B.YFPZNO=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            Open;
          end;
          if ADOQueryCmd.IsEmpty = False then
          begin
            CDS_Main.EnableControls;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('财务已确认,禁止修改!', '提示', 0);
            Exit;
          end;

          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('exec P_Update_SXPB_QTY ' + quotedstr(trim(Self.CDS_Main.FieldByName('SPID').AsString)) + ',' + quotedstr(Trim(cxCurrencyEdit2.Text)));
            sql.Add('exec P_CW_SXPB ''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
            execsql;
          end;
          with ADOQueryCmd do
          begin
            close;
            sql.Clear;
            sql.Add('insert into SY_SysLog(operor,opertime,Model,acction,opevent,result) values( ');
            sql.Add(' ' + quotedstr(trim(DName)));
            sql.Add(',getdate() ');
            sql.Add(',' + quotedstr(trim(self.Caption)));
            sql.Add(',' + quotedstr(trim('修改匹数')));
            sql.Add(',' + quotedstr(trim('入库单号：' + trim(Self.CDS_Main.FieldByName('SPID').AsString) + ' 原匹数:' + trim(Self.CDS_Main.FieldByName('piqty').AsString))));
            sql.Add(',' + quotedstr(trim('成功')));
            sql.Add(')');
            execsql;
          end;
          with ADOQueryCmd do
          begin
            Close;
            sql.Clear;
            sql.Add('Update CK_SXPB_CR Set MXKCQty=(select sum(isnull(Qty,0)*CRQtyFlag) from CK_SXPB_CR A where A.FZSPID=CK_SXPB_CR.SPID)');

            sql.Add(' where SPID=' + quotedstr(trim(Self.CDS_Main.FieldByName('SPID').AsString)));
            ExecSQL;
          end;
          with ADOQueryTemp do
          begin
            Close;
            sql.Clear;
            sql.Add('select * from CK_SXPB_CR where SPID=' + quotedstr(trim(Self.CDS_Main.FieldByName('SPID').AsString)));
            Open;
          end;
          if ADOQueryTemp.FieldByName('MXKCQty').Value < 0 then
          begin
            CDS_Main.EnableControls;
            ADOQueryCmd.Connection.RollbackTrans;
            Application.MessageBox('入库数小于出库数不能保存!', '提示', 0);
            Exit;
          end;

        end;
        Next;
      end;
    end;
    CDS_Main.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Application.MessageBox('修改成功!', '提示', 0);
  except
    CDS_Main.EnableControls;
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('修改异常!', '提示', 0);
    Exit;
  end;

end;

procedure TfrmDJBCKOutList.ToolButton7Click(Sender: TObject);
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' update CK_SXPB_CR set PrintCount=0 ');
        sql.Add(' where SPId=''' + Trim(CDS_Main.fieldbyname('SPId').AsString) + ''' ');
        ExecSQL;

      end;
      CDS_Main.Delete;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    Application.MessageBox('清零成功!', '提示', 0);
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('清零异常!', '提示', 0);
  end;
end;

procedure TfrmDJBCKOutList.cxTabControl1Change(Sender: TObject);
begin
  TBRafresh.Click();
end;

procedure TfrmDJBCKOutList.Tv1CustomDrawIndicatorCell(Sender: TcxGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxCustomGridIndicatorItemViewInfo; var ADone: Boolean);
var
  FValue: string;
  FBounds: TRect;
begin
  FBounds := AViewInfo.Bounds;
  if (AViewInfo is TcxGridIndicatorRowItemViewInfo) then
  begin
    ACanvas.FillRect(FBounds);
    ACanvas.DrawComplexFrame(FBounds, clBtnHighlight, clBtnShadow, [bBottom, bLeft, bRight], 1);
    FValue := IntToStr(TcxGridIndicatorRowItemViewInfo(AViewInfo).GridRecord.Index + 1);
    InflateRect(FBounds, -1, -1);    //Platform   specific.   May   not   work   on   Linux.
    ACanvas.Font.Color := clBlack;
    ACanvas.Brush.Style := bsClear;
    ACanvas.DrawText(FValue, FBounds, cxAlignCenter or cxAlignTop);
    ADone := True;
  end;
end;

procedure TfrmDJBCKOutList.CKorderNoKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = #13 then
  begin
    InitGrid();
  end;
end;

procedure TfrmDJBCKOutList.CKorderNoChange(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmDJBCKOutList.ToolButton8Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty = True then
    Exit;

  Panel2.Visible := True;
  Label30.Caption := Trim(CDS_Main.fieldbyname('spid').AsString);
  Label29.Caption := '出到订单号:' + Trim(CDS_Main.fieldbyname('CKorderNo').AsString);
  Label31.Caption := '颜色：' + Trim(CDS_Main.fieldbyname('SPColor').AsString);
end;

procedure TfrmDJBCKOutList.Button6Click(Sender: TObject);
begin
  Panel2.Visible := False;
end;

procedure TfrmDJBCKOutList.Button7Click(Sender: TObject);
begin
  if trim(edit2.Text) = '' then
  begin
    Application.MessageBox('次品原因不能为空!', '提示', 0);
    exit;
  end;
  if trim(edit3.Text) = '' then
  begin
    Application.MessageBox('处理方式不能为空!', '提示', 0);
    exit;
  end;

  if trim(cxCurrencyEdit3.Text) = '' then
  begin
    Application.MessageBox('匹数不能为空!', '提示', 0);
    exit;
  end;

  if trim(cxCurrencyEdit4.Text) = '' then
  begin
    Application.MessageBox('数量不能为空!', '提示', 0);
    exit;
  end;

  try
    ADOQueryCmd.Connection.BeginTrans;

    with ADOQueryCmd do
    begin
      Close;
      sql.Clear;
      sql.Add(' exec  P_Do_SCCPK @SPID=' + QuotedStr(Trim(Label30.Caption)));
      SQL.Add(',@REASON=' + QuotedStr(Trim(edit2.Text)));
      SQL.Add(',@ways=' + QuotedStr(Trim(edit3.Text)));
      SQL.Add(',@dname=' + QuotedStr(Trim(DName)));
      SQL.Add(',@ps=' + QuotedStr(Trim(cxCurrencyEdit3.Text)));
      SQL.Add(',@qty=' + QuotedStr(Trim(cxCurrencyEdit4.Text)));
      ExecSQL;

    end;

    ADOQueryCmd.Connection.CommitTrans;
    Application.MessageBox('生成成功!', '提示', 0);
    Panel2.Visible := False;
    InitGrid();
  except
    ADOQueryCmd.Connection.RollbackTrans;
    Application.MessageBox('生成异常!', '提示', 0);
  end;
end;

procedure TfrmDJBCKOutList.EDIT2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'WFBCD';
      flagname := '疵点';
      fnote := True;
      V1Note.Caption := '英文名称';
      if ShowModal = 1 then
      begin
        EDIT2.Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmDJBCKOutList.EDIT3PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'cpCLFS';
      flagname := '次品处理方式';

      if ShowModal = 1 then
      begin
        EDIT3.Text := Trim(ClientDataSet1.fieldbyname('ZDYName').AsString);
      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmDJBCKOutList.ToolButton9Click(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;

  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Main.DisableControls;
    with CDS_Main do
    begin
      First;
      while not eof do
      begin
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add(' exec P_UPdate_LCKJY ''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
          execsql;
        end;
        CDS_Main.Next;
      end;
    end;
    ADOQueryCmd.Connection.CommitTrans;
    CDS_Main.EnableControls;
  except
    ADOQueryCmd.Connection.RollbackTrans;
    CDS_Main.EnableControls;
    Application.MessageBox('更新异常!', '提示', 0);
  end;
  InitGrid();
end;

procedure TfrmDJBCKOutList.JYZTChange(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmDJBCKOutList.CheckBox1Click(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmDJBCKOutList.ToolButton10Click(Sender: TObject);
var
  fPrintFile: string;
var
  WSql, WSQL2: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('检验指示单标签A4.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf';
  WSql := '';
  WSQL2 := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      if WSql <> '' then
      begin
        WSql := WSql + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
        WSQL2 := WSQL2 + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      end
      else
      begin
        WSql := 'where A.SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
        WSQL2 := 'where SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      end;
      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;
  WSql := WSql + ')';
  WSQL2 := WSQL2 + ')';

  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add(' update CK_SXPB_CR  set PrintCount=isnull(PrintCount,0)+1 ');
    sql.Add(WSQL2);
//    ShowMessage(SQL.Text);
    ExecSQL;
  end;
  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
//    sql.Add(' select A.*,D.*  ');
//    sql.Add(',KHConno=(select KHConno from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(',MPRTBZNote=(select MPRTBZNote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(',PRTColorNo=(select PRTColorNo from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',PRTOrderQty=(select PRTOrderQty from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',PRTEColor=(select PRTEColor from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',LYnote=(select LYnote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(' from CK_SXPB_CR A');
//    sql.Add(' left join TP_File D on D.TFID=A.SPID ');

    sql.Add(' EXEC P_Print_JYZSD @WSql=' + QuotedStr(WSql));
//    ShowMessage(SQL.Text);
    Open;
  end;
  SCreateCDS20(ADOQueryPrint, CDS_PRT);
  SInitCDSData20(ADOQueryPrint, CDS_PRT);
  if FileExists(fPrintFile) then
  begin
    RM1.LoadFromFile(fPrintFile);
    RM1.DefaultCopies := StrToIntDef(Edit1.Text, 1);
    RM1.ShowPrintDialog := TRUE;
    RM1.ShowReport;
//    RM1.PrintReport;
  end
  else
  begin
    CDS_Main.EnableControls;
    Application.MessageBox(PChar('没有找' + ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf'), '提示', 0);
    Exit;
  end;
end;

procedure TfrmDJBCKOutList.Button8Click(Sender: TObject);
var
  fPrintFile: string;
var
  WSql, WSQL2: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('检验指示单标签A4.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf';
  WSql := '';
  WSQL2 := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      if WSql <> '' then
      begin
        WSql := WSql + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
        WSQL2 := WSQL2 + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      end
      else
      begin
        WSql := 'where A.SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
        WSQL2 := 'where SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      end;
      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;
  WSql := WSql + ')';
  WSQL2 := WSQL2 + ')';

  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add(' update CK_SXPB_CR  set PrintCount=isnull(PrintCount,0)+1 ');
    sql.Add(WSQL2);
//    ShowMessage(SQL.Text);
    ExecSQL;
  end;
  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
//    sql.Add(' select A.*,D.*  ');
//    sql.Add(',KHConno=(select KHConno from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(',MPRTBZNote=(select MPRTBZNote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(',PRTColorNo=(select PRTColorNo from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',PRTOrderQty=(select PRTOrderQty from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',PRTEColor=(select PRTEColor from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',LYnote=(select LYnote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(' from CK_SXPB_CR A');
//    sql.Add(' left join TP_File D on D.TFID=A.SPID ');

    sql.Add(' EXEC P_Print_JYZSD @WSql=' + QuotedStr(WSql));
//    ShowMessage(SQL.Text);
    Open;
  end;
  SCreateCDS20(ADOQueryPrint, CDS_PRT);
  SInitCDSData20(ADOQueryPrint, CDS_PRT);
  if FileExists(fPrintFile) then
  begin
    RM1.LoadFromFile(fPrintFile);
    RM1.DefaultCopies := StrToIntDef(Edit1.Text, 1);
//    RM1.ShowReport;
    RM1.PrintReportL(ComboBox2.Text);
  end
  else
  begin
    CDS_Main.EnableControls;
    Application.MessageBox(PChar('没有找' + ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf'), '提示', 0);
    Exit;
  end;
end;

procedure TfrmDJBCKOutList.Button11Click(Sender: TObject);
var
  fPrintFile: string;
var
  WSql, WSQL2: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('检验指示单标签A4.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf';
  WSql := '';
  WSQL2 := '';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while CDS_Main.Locate('SSel', True, []) do
    begin
      if WSql <> '' then
      begin
        WSql := WSql + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
        WSQL2 := WSQL2 + ',' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      end
      else
      begin
        WSql := 'where A.SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
        WSQL2 := 'where SPID in (' + QuotedStr(Trim(CDS_Main.fieldbyname('SPId').AsString));
      end;
      Edit;
      FieldByName('SSel').Value := False;
      Post;
    end;
  end;
  CDS_Main.EnableControls;
  WSql := WSql + ')';
  WSQL2 := WSQL2 + ')';

  with ADOQueryCmd do
  begin
    Close;
    sql.Clear;
    sql.Add(' update CK_SXPB_CR  set PrintCount=isnull(PrintCount,0)+1 ');
    sql.Add(WSQL2);
//    ShowMessage(SQL.Text);
    ExecSQL;
  end;
  with ADOQueryPrint do
  begin
    Close;
    sql.Clear;
//    sql.Add(' select A.*,D.*  ');
//    sql.Add(',KHConno=(select KHConno from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(',MPRTBZNote=(select MPRTBZNote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(',PRTColorNo=(select PRTColorNo from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',PRTOrderQty=(select PRTOrderQty from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',PRTEColor=(select PRTEColor from JYOrder_Sub X where X.SubId=A.ORDSubIdCK)  ');
//    sql.Add(',LYnote=(select LYnote from JYOrder_Main X where X.MainId=A.ORDMainIdCK)  ');
//    sql.Add(' from CK_SXPB_CR A');
//    sql.Add(' left join TP_File D on D.TFID=A.SPID ');

    sql.Add(' EXEC P_Print_JYZSD @WSql=' + QuotedStr(WSql));
//    ShowMessage(SQL.Text);
    Open;
  end;
  SCreateCDS20(ADOQueryPrint, CDS_PRT);
  SInitCDSData20(ADOQueryPrint, CDS_PRT);
  if FileExists(fPrintFile) then
  begin
    RM1.LoadFromFile(fPrintFile);
    RM1.DefaultCopies := StrToIntDef(Edit1.Text, 1);
    RM1.ShowReport;
//    RM1.PrintReportL(ComboBox2.Text);
  end
  else
  begin
    CDS_Main.EnableControls;
    Application.MessageBox(PChar('没有找' + ExtractFilePath(Application.ExeName) + 'Report\检验指示单标签A4.rmf'), '提示', 0);
    Exit;
  end;
end;

procedure TfrmDJBCKOutList.Button10Click(Sender: TObject);
begin
  Panel3.Visible := False;
end;

procedure TfrmDJBCKOutList.Tv1CustomDrawCell(Sender: TcxCustomGridTableView; ACanvas: TcxCanvas; AViewInfo: TcxGridTableDataCellViewInfo; var ADone: Boolean);
begin
  if (AViewInfo.GridRecord.Values[Tv1Column7.Index] > '5') or (AViewInfo.GridRecord.Values[Tv1Column7.Index] < '-5') then
    ACanvas.Brush.Color := CLRED;
end;

end.

